      SUBROUTINE ZP17D(A,NREAL,ROOT,IERR)
      DIMENSION A(5),ROOT(4),B(5),D(4),ROOT1(3)
      INTEGER NREAL,IERR,N,I,IERR1,J
      DOUBLE PRECISION A,ROOT,AA,ALPHA,B,BB,BETA,CC,D,DD,
     1DELTA,R,R1,RO,ROOT1,X1,XN,XM,XND,XMD,GAMMA,DSQRT
      NREAL=0
      DO 1 I=1,2
      R=A(I)
      J=6-I
      A(I)=A(J)
      A(J)=R
    1 CONTINUE
      IF(A(5).NE.0.D0) GO TO 2
      IERR=65
      CALL UTZP11(IERR,17)
      GO TO 35
    2 CONTINUE
      B(1)=1.0D0
      B(2)=A(4)/A(5)
      B(3)=A(3)/A(5)
      B(4)=A(2)/A(5)
      B(5)=A(1)/A(5)
      D(4)=1.0D0
      D(3)=-B(3)
      D(2)=B(2)*B(4)-4.0D0*B(5)
      D(1)=B(5)*(4.0D0*B(3)-B(2)*B(2))-B(4)*B(4)
      R1=D(1)
      D(1)=D(4)
      D(4)=R1
      R1=D(2)
      D(2)=D(3)
      D(3)=R1
      CALL ZP16D(D,N,ROOT1,IERR1)
      IF(N-1) 4,4,3
    3 ROOT1(1)=ROOT1(3)
    4 X1=B(2)*B(2)*.25D0-B(3)+ROOT1(1)
      IF(X1) 29,5,6
    5 XM=0.D0
      XN=DSQRT(.25D0*ROOT1(1)*ROOT1(1)-B(5))
      GO TO 7
    6 XM=DSQRT(X1)
      XN=(B(2)*ROOT1(1)-2.0D0*B(4))*.25D0/XM
    7 ALPHA=.5D0*B(2)*B(2)-ROOT1(1)-B(3)
      BETA=4.0D0*XN-B(2)*XM
      GAMMA=ALPHA+BETA
      DELTA=ALPHA-BETA
      AA=-.5D0*B(2)
      J=1
      IF(GAMMA) 9,8,8
    8 NREAL=NREAL+2
      J=0
      GAMMA=DSQRT(GAMMA)
      GO TO 10
    9 GAMMA=DSQRT(-GAMMA)
   10 IF(DELTA) 12,11,11
   11 NREAL=NREAL+2
      DELTA=DSQRT(DELTA)
      GO TO 13
   12 DELTA=DSQRT(-DELTA)
   13 J=NREAL+J
      GO TO (14,16,17,18),J
      ROOT(2)=.5D0*GAMMA
   14 ROOT(1)=(AA+XM)*.5D0
   15 ROOT(3)=(AA-XM)*.5D0
      ROOT(4)=.5D0*DELTA
      GO TO 33
   16 ROOT(2)=(AA+XM+GAMMA)*.5D0
      ROOT(1)=(AA+XM-GAMMA)*.5D0
      GO TO 15
   17 ROOT(2)=(AA-XM+DELTA)*.5D0
      ROOT(1)=(AA-XM-DELTA)*.5D0
      ROOT(3)=(AA+XM)*.5D0
      ROOT(4)=.5D0*GAMMA
      GO TO 33
   18 BB=(AA+XM+GAMMA)*.5D0
      DD=(AA-XM+DELTA)*.5D0
      CC=(AA-XM-DELTA)*.5D0
      AA=(AA+XM-GAMMA)*.5D0
      IF(AA-CC) 19,19,26
   19 ROOT(1)=AA
      IF(CC-BB) 20,20,25
   20 ROOT(2)=CC
      IF(BB-DD) 21,21,23
   21 ROOT(3)=BB
   22 ROOT(4)=DD
      GO TO 33
   23 ROOT(3)=DD
   24 ROOT(4)=BB
      GO TO 33
   25 ROOT(2)=BB
      ROOT(3)=CC
      GO TO 22
   26 ROOT(1)=CC
      IF(DD-AA) 27,27,28
   27 ROOT(2)=DD
      ROOT(3)=AA
      GO TO 24
   28 ROOT(2)=AA
      IF(DD-BB) 23,23,21
   29 XMD=DSQRT(-X1)
      XND=(2.0D0*B(4)-B(2)*ROOT1(1))*.25D0/XMD
      ALPHA=.5D0*B(2)*B(2)-ROOT1(1)-B(3)
      BETA=4.0D0*XND-B(2)*XMD
      RO=DSQRT(ALPHA*ALPHA+BETA*BETA)
      GAMMA=DSQRT(.5D0*(ALPHA+RO))
      IF(GAMMA) 31,30,31
   30 DELTA=DSQRT(-ALPHA)
      GO TO 32
   31 DELTA=BETA*.5D0/GAMMA
   32 ROOT(1)=.5D0*(-.5D0*B(2)+GAMMA)
      ROOT(2)=.5D0*(XMD+DELTA)
      ROOT(3)=.5D0*(-.5D0*B(2)-GAMMA)
      ROOT(4)=.5D0*(XMD-DELTA)
   33 DO 34 I=1,2
      R=A(I)
      J=6-I
      A(I)=A(J)
      A(J)=R
   34 CONTINUE
   35 RETURN
      END
